import { IRecordLocking } from "./abstractions/IRecordLocking";
import { ApolloClient } from "apollo-client";
import { IRecordLockingGetLockRecord } from "./abstractions/IRecordLockingGetLockRecord";
import { IRecordLockingIsEntryLocked } from "./abstractions/IRecordLockingIsEntryLocked";
import { IRecordLockingListLockRecords } from "./abstractions/IRecordLockingListLockRecords";
import { IRecordLockingLockEntry } from "./abstractions/IRecordLockingLockEntry";
import { IRecordLockingUnlockEntry } from "./abstractions/IRecordLockingUnlockEntry";
import { IRecordLockingUnlockEntryRequest } from "./abstractions/IRecordLockingUnlockEntryRequest";
import { IRecordLockingError, IRecordLockingRecord } from "../types";
import { IRecordLockingClient } from "./abstractions/IRecordLockingClient";
import { IRecordLockingUpdateEntryLock } from "./abstractions/IRecordLockingUpdateEntryLock";
import { IRecordLockingGetLockedEntryLockRecord } from "./abstractions/IRecordLockingGetLockedEntryLockRecord";
export interface ICreateRecordLockingParams {
    client: ApolloClient<any>;
    setLoading: (loading: boolean) => void;
}
export interface IRecordLockingParams {
    client: IRecordLockingClient;
    setLoading: (loading: boolean) => void;
    getLockRecord: IRecordLockingGetLockRecord;
    getLockedEntryLockRecord: IRecordLockingGetLockedEntryLockRecord;
    isEntryLocked: IRecordLockingIsEntryLocked;
    listLockRecords: IRecordLockingListLockRecords;
    lockEntry: IRecordLockingLockEntry;
    unlockEntry: IRecordLockingUnlockEntry;
    unlockEntryRequest: IRecordLockingUnlockEntryRequest;
    updateEntryLock: IRecordLockingUpdateEntryLock;
}
export interface IOnErrorCb {
    (error: IRecordLockingError): void;
}
export declare const createRecordLocking: <T extends IRecordLockingRecord>(config: ICreateRecordLockingParams) => IRecordLocking;
